<?php

namespace Drupal\jmol\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\file\Plugin\Field\FieldFormatter\GenericFileFormatter;

/**
 * Plugin implementation of the 'jmol' formatter.
 *
 * @FieldFormatter(
 *   id = "jmol",
 *   label = @Translation("Jmol object"),
 *   field_types = {
 *     "file"
 *   }
 * )
 */
class JmolFormatter extends GenericFileFormatter {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = parent::viewElements($items, $langcode);
    foreach ($elements as &$element) {
      $file = $element['#file'];
      $uri = $file->getFileUri();
      $path = '/sites/default/files/' . substr($uri, 9);
      $info = [
        'width' => 400,
        'height' => 400,
        'color' => "0xC0C0C0",
        'disableJ2SLoadMonitor' => TRUE,
        'disableInitialConsole' => TRUE,
        'addSelectionOptions' => TRUE,
        'serverURL' => "http://chemapps.stolaf.edu/jmol/jsmol/php/jsmol.php",
        'use' => "HTML5",
        'readyFunction' => NULL,
        'src' => $path,
      ];
      $element = [
        '#type' => 'jmol',
        '#info' => $info,
      ];
    }
    return $elements;
  }
}
